blob: 52f5e0c4016482c8e78878392a7f48f0685bab0f [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
David Brazdil4846d132015-01-15 19:07:08 +000042checker="${progdir}/../tools/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043
44export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070045export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010046export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070047export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070048export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070049
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070050# If dx was not set by the environment variable, assume it is in the path.
51if [ -z "$DX" ]; then
52 export DX="dx"
53fi
54
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080055# If jasmin was not set by the environment variable, assume it is in the path.
56if [ -z "$JASMIN" ]; then
57 export JASMIN="jasmin"
58fi
59
Andreas Gampe8fda9f22014-10-03 16:15:37 -070060# If smali was not set by the environment variable, assume it is in the path.
61if [ -z "$SMALI" ]; then
62 export SMALI="smali"
63fi
64
65# If dexmerger was not set by the environment variable, assume it is in the path.
66if [ -z "$DXMERGER" ]; then
67 export DXMERGER="dexmerger"
68fi
69
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080070
jeffhao5d1ac922011-09-29 17:41:15 -070071info="info.txt"
72build="build"
73run="run"
74expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070075check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070076output="output.txt"
77build_output="build-output.txt"
David Brazdil4846d132015-01-15 19:07:08 +000078cfg_output="cfg-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070079lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070080run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +000081build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -070082
Alex Light9d722532014-07-22 18:07:12 -070083prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -070084target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070085dev_mode="no"
86update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -070087debug_mode="no"
88relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -080089runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070090usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070091build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070092suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -070093trace="false"
Alex Lighte7873ec2014-08-12 09:53:50 -070094basic_verify="false"
95gc_verify="false"
96gc_stress="false"
Alex Lightbfac14a2014-07-30 09:41:21 -070097always_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -070098have_dex2oat="yes"
99have_patchoat="yes"
100have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700101image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -0700102pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000103android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700104
105while true; do
106 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700107 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700108 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100109 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700110 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800111 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700112 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800113 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700114 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700115 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100116 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700117 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800118 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700119 lib="libart.so"
120 shift
121 elif [ "x$1" = "x--dalvik" ]; then
122 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800123 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700124 shift
Alex Light03a112d2014-08-25 13:25:56 -0700125 elif [ "x$1" = "x--no-dex2oat" ]; then
126 have_dex2oat="no"
127 shift
128 elif [ "x$1" = "x--no-patchoat" ]; then
129 have_patchoat="no"
130 shift
131 elif [ "x$1" = "x--no-image" ]; then
132 have_image="no"
133 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700134 elif [ "x$1" = "x--pic-image" ]; then
135 pic_image_suffix="-pic"
136 shift
137 elif [ "x$1" = "x--pic-test" ]; then
138 run_args="${run_args} --pic-test"
139 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700140 elif [ "x$1" = "x--relocate" ]; then
141 relocate="yes"
142 shift
143 elif [ "x$1" = "x--no-relocate" ]; then
144 relocate="no"
145 shift
146 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100147 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700148 prebuild_mode="yes"
149 shift;
150 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100151 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700152 prebuild_mode="no"
153 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700154 elif [ "x$1" = "x--gcverify" ]; then
155 basic_verify="true"
156 gc_verify="true"
157 shift
158 elif [ "x$1" = "x--gcstress" ]; then
159 basic_verify="true"
160 gc_stress="true"
161 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700162 elif [ "x$1" = "x--image" ]; then
163 shift
164 image="$1"
165 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700166 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000167 elif [ "x$1" = "x-Xcompiler-option" ]; then
168 shift
169 option="$1"
170 run_args="${run_args} -Xcompiler-option $option"
171 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700172 elif [ "x$1" = "x--runtime-option" ]; then
173 shift
174 option="$1"
175 run_args="${run_args} --runtime-option $option"
176 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700177 elif [ "x$1" = "x--gdb-arg" ]; then
178 shift
179 gdb_arg="$1"
180 run_args="${run_args} --gdb-arg $gdb_arg"
181 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700182 elif [ "x$1" = "x--debug" ]; then
183 run_args="${run_args} --debug"
184 shift
185 elif [ "x$1" = "x--gdb" ]; then
186 run_args="${run_args} --gdb"
187 dev_mode="yes"
188 shift
189 elif [ "x$1" = "x--zygote" ]; then
190 run_args="${run_args} --zygote"
191 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800192 elif [ "x$1" = "x--interpreter" ]; then
193 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700194 image_suffix="-interpreter"
195 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800196 elif [ "x$1" = "x--jit" ]; then
197 run_args="${run_args} --jit"
Mathieu Chartiere2a12c02015-02-27 13:21:15 -0800198 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800199 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700200 elif [ "x$1" = "x--optimizing" ]; then
201 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
202 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800203 shift
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000204 elif [ "x$1" = "x--quick" ]; then
205 run_args="${run_args} -Xcompiler-option --compiler-backend=Quick"
206 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700207 elif [ "x$1" = "x--no-verify" ]; then
208 run_args="${run_args} --no-verify"
209 shift
210 elif [ "x$1" = "x--no-optimize" ]; then
211 run_args="${run_args} --no-optimize"
212 shift
213 elif [ "x$1" = "x--no-precise" ]; then
214 run_args="${run_args} --no-precise"
215 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700216 elif [ "x$1" = "x--invoke-with" ]; then
217 shift
218 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700219 if [ "x$what" = "x" ]; then
220 echo "$0 missing argument to --invoke-with" 1>&2
221 usage="yes"
222 break
223 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700224 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700225 shift
226 elif [ "x$1" = "x--dev" ]; then
227 run_args="${run_args} --dev"
228 dev_mode="yes"
229 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700230 elif [ "x$1" = "x--build-only" ]; then
231 build_only="yes"
232 shift
233 elif [ "x$1" = "x--output-path" ]; then
234 shift
235 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700236 if [ "x$tmp_dir" = "x" ]; then
237 echo "$0 missing argument to --output-path" 1>&2
238 usage="yes"
239 break
240 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700241 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000242 elif [ "x$1" = "x--android-root" ]; then
243 shift
244 if [ "x$1" = "x" ]; then
245 echo "$0 missing argument to --android-root" 1>&2
246 usage="yes"
247 break
248 fi
249 android_root="$1"
250 run_args="${run_args} --android-root $1"
251 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700252 elif [ "x$1" = "x--update" ]; then
253 update_mode="yes"
254 shift
255 elif [ "x$1" = "x--help" ]; then
256 usage="yes"
257 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700258 elif [ "x$1" = "x--64" ]; then
259 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700260 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700261 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200262 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700263 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200264 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700265 elif [ "x$1" = "x--always-clean" ]; then
266 always_clean="yes"
267 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800268 elif [ "x$1" = "x--dex2oat-swap" ]; then
269 run_args="${run_args} --dex2oat-swap"
270 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700271 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700272 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700273 usage="yes"
274 break
275 else
276 break
277 fi
278done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700279
280# tmp_dir may be relative, resolve.
281#
282# Cannot use realpath, as it does not exist on Mac.
283# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700284# Cannot use readlink -m, as it does not exist on Mac.
285# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700286noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700287tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700288mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700289
Alex Lighte7873ec2014-08-12 09:53:50 -0700290if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800291 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
292 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700293fi
294if [ "$gc_verify" = "true" ]; then
295 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
296fi
297if [ "$gc_stress" = "true" ]; then
298 run_args="${run_args} --runtime-option -Xgc:SS --runtime-option -Xms2m --runtime-option -Xmx2m"
299fi
Jeff Hao85139a32014-07-23 11:52:52 -0700300if [ "$trace" = "true" ]; then
301 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin --runtime-option -Xmethod-trace-file-size:2000000"
302fi
303
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700304# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100305# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700306function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100307 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800308 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700309 if [ "x${suffix64}" = "x64" ]; then
310 target_arch_name=${grep64bit}
311 else
312 target_arch_name=${grep32bit}
313 fi
314}
315
Alex Lighta59dd802014-07-02 16:28:08 -0700316if [ "$target_mode" = "no" ]; then
317 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700318 if [ "$prebuild_mode" = "yes" ]; then
319 echo "--prebuild with --jvm is unsupported";
320 exit 1;
321 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700322 fi
323fi
324
Alex Light03a112d2014-08-25 13:25:56 -0700325if [ "$have_patchoat" = "no" ]; then
326 run_args="${run_args} --no-patchoat"
327fi
328
329if [ "$have_dex2oat" = "no" ]; then
330 run_args="${run_args} --no-dex2oat"
331fi
332
Jeff Hao201803f2013-11-20 18:11:39 -0800333if [ ! "$runtime" = "jvm" ]; then
334 run_args="${run_args} --lib $lib"
335fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700336
Jeff Hao201803f2013-11-20 18:11:39 -0800337if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700338 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100339 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700340 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
341 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
342 else
343 true # defaults to using target BOOTCLASSPATH
344 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800345elif [ "$runtime" = "art" ]; then
346 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100347 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800348 if [ -z "$ANDROID_BUILD_TOP" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100349 export ANDROID_BUILD_TOP=$oldwd
Brian Carlstrom43534862014-02-19 01:13:52 -0800350 fi
351 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100352 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800353 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000354 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700355 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800356 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700357 guess_arch_name
358 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000359 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800360 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700361 if [ "$relocate" = "yes" ]; then
362 run_args="${run_args} --relocate"
363 else
364 run_args="${run_args} --no-relocate"
365 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700366fi
367
Alex Light03a112d2014-08-25 13:25:56 -0700368if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700369 if [ "$runtime" != "art" ]; then
370 echo "--no-image is only supported on the art runtime"
371 exit 1
372 fi
373 if [ "$target_mode" = "no" ]; then
374 framework="${ANDROID_HOST_OUT}/framework"
375 bpath_suffix="-hostdex"
376 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000377 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700378 bpath_suffix=""
379 fi
380 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
381 # fail since these jar files will be stripped.
382 bpath="${framework}/core-libart${bpath_suffix}.jar"
383 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
384 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
385 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
386 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
387 # Pass down the bootclasspath
388 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700389 run_args="${run_args} --no-image"
390fi
391
jeffhao5d1ac922011-09-29 17:41:15 -0700392if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
393 echo "--dev and --update are mutually exclusive" 1>&2
394 usage="yes"
395fi
396
397if [ "$usage" = "no" ]; then
398 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
399 test_dir=`basename "$oldwd"`
400 else
401 test_dir="$1"
402 fi
403
404 if [ '!' -d "$test_dir" ]; then
405 td2=`echo ${test_dir}-*`
406 if [ '!' -d "$td2" ]; then
407 echo "${test_dir}: no such test directory" 1>&2
408 usage="yes"
409 fi
410 test_dir="$td2"
411 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700412 # Shift to get rid of the test name argument. The rest of the arguments
413 # will get passed to the test run.
414 shift
415fi
416
417if [ "$usage" = "yes" ]; then
418 prog=`basename $prog`
419 (
420 echo "usage:"
421 echo " $prog --help Print this message."
422 echo " $prog [options] [test-name] Run test normally."
423 echo " $prog --dev [options] [test-name] Development mode" \
424 "(dumps to stdout)."
425 echo " $prog --update [options] [test-name] Update mode" \
426 "(replaces expected.txt)."
427 echo ' Omitting the test name or specifying "-" will use the' \
428 "current directory."
429 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000430 echo " -O Run non-debug rather than debug build (off by default)."
431 echo " -Xcompiler-option Pass an option to the compiler."
432 echo " --runtime-option Pass an option to the runtime."
433 echo " --debug Wait for a debugger to attach."
434 echo " --gdb Run under gdb; incompatible with some tests."
435 echo " --build-only Build test files only (off by default)."
436 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800437 echo " --jit Enable jit (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000438 echo " --optimizing Enable optimizing compiler (off by default)."
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000439 echo " --quick Use Quick compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000440 echo " --no-verify Turn off verification (on by default)."
441 echo " --no-optimize Turn off optimization (on by default)."
442 echo " --no-precise Turn off precise GC (on by default)."
443 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700444 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000445 echo " other runtime options are ignored."
446 echo " --no-dex2oat Run as though dex2oat was failing."
447 echo " --no-patchoat Run as though patchoat was failing."
448 echo " --prebuild Run dex2oat on the files before starting test. (default)"
449 echo " --no-prebuild Do not run dex2oat on the files before starting"
450 echo " the test."
451 echo " --relocate Force the use of relocating in the test, making"
452 echo " the image and oat files be relocated to a random"
453 echo " address before running. (default)"
454 echo " --no-relocate Force the use of no relocating in the test"
455 echo " --host Use the host-mode virtual machine."
456 echo " --invoke-with Pass --invoke-with option to runtime."
457 echo " --dalvik Use Dalvik (off by default)."
458 echo " --jvm Use a host-local RI virtual machine."
459 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700460 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000461 echo " --64 Run the test in 64-bit mode"
462 echo " --trace Run with method tracing"
463 echo " --gcstress Run with gc stress testing"
464 echo " --gcverify Run with gc verification"
465 echo " --always-clean Delete the test files even if the test fails."
466 echo " --android-root [path] The path on target for the android root. (/system by default)."
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800467 echo " --dex2oat-swap Use a dex2oat swap file."
jeffhao5d1ac922011-09-29 17:41:15 -0700468 ) 1>&2
469 exit 1
470fi
471
472cd "$test_dir"
473test_dir=`pwd`
474
475td_info="${test_dir}/${info}"
476td_expected="${test_dir}/${expected}"
477
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700478if [ ! -r $td_info ]; then
479 echo "${test_dir}: missing file $td_info" 1>&2
480 exit 1
481fi
482
483if [ ! -r $td_expected ]; then
484 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700485 exit 1
486fi
487
488# copy the test to a temp dir and run it
489
Elliott Hughes510c8782011-10-06 10:57:34 -0700490echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700491
492rm -rf "$tmp_dir"
493cp -Rp "$test_dir" "$tmp_dir"
494cd "$tmp_dir"
495
496if [ '!' -r "$build" ]; then
497 cp "${progdir}/etc/default-build" build
498fi
499
500if [ '!' -r "$run" ]; then
501 cp "${progdir}/etc/default-run" run
502fi
503
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700504if [ '!' -r "$check_cmd" ]; then
505 cp "${progdir}/etc/default-check" check
506fi
507
jeffhao5d1ac922011-09-29 17:41:15 -0700508chmod 755 "$build"
509chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700510chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700511
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700512export TEST_NAME=`basename ${test_dir}`
513
David Brazdil4846d132015-01-15 19:07:08 +0000514# Tests named '<number>-checker-*' will also have their CFGs verified with
515# Checker when compiled with Optimizing on host.
516if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
517 # Build Checker DEX files without dx's optimizations so the input to dex2oat
518 # better resembles the Java source. We always build the DEX the same way, even
519 # if Checker is not invoked and the test only runs the program.
520 build_args="${build_args} --dx-option --no-optimize"
521
522 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" ]; then
523 run_checker="yes"
524 run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \
525 -Xcompiler-option -j1"
526 fi
527fi
528
Ian Rogers997f0f92014-06-21 22:58:05 -0700529# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
530file_size_limit=2048
531if echo "$test_dir" | grep 089; then
532 file_size_limit=5120
533elif echo "$test_dir" | grep 083; then
534 file_size_limit=5120
535fi
Alex Lighta59dd802014-07-02 16:28:08 -0700536if ! ulimit -S "$file_size_limit"; then
Ian Rogers997f0f92014-06-21 22:58:05 -0700537 echo "ulimit file size setting failed"
538fi
539
jeffhao5d1ac922011-09-29 17:41:15 -0700540good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000541good_build="yes"
542good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700543if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000544 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700545 build_exit="$?"
546 echo "build exit status: $build_exit" 1>&2
547 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800548 echo "${test_dir}: running..." 1>&2
549 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700550 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000551
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800552 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000553 if [ "$run_checker" = "yes" ]; then
554 "$checker" "$cfg_output" "$tmp_dir" 2>&1
555 checker_exit="$?"
556 if [ "$checker_exit" = "0" ]; then
557 good="yes"
558 fi
559 echo "checker exit status: $checker_exit" 1>&2
560 else
561 good="yes"
562 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800563 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000564 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700565 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700566elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000567 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700568 build_exit="$?"
569 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800570 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700571 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000572 if [ "$run_checker" = "yes" ]; then
573 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
574 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700575 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
576 good="yes"
577 else
578 cat "$build_output" 1>&2
579 echo "build exit status: $build_exit" 1>&2
580 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700581elif [ "$build_only" = "yes" ]; then
582 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000583 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700584 build_exit="$?"
585 if [ "$build_exit" '!=' '0' ]; then
586 cp "$build_output" "$output"
587 echo "build exit status: $build_exit" >>"$output"
588 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
589 if [ "$?" '!=' "0" ]; then
590 good="no"
591 echo "BUILD FAILED For ${TEST_NAME}"
592 fi
593 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700594 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700595 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700596 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700597else
David Brazdil4846d132015-01-15 19:07:08 +0000598 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700599 build_exit="$?"
600 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800601 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700602 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000603 run_exit="$?"
604 if [ "$run_exit" != "0" ]; then
605 echo "run exit status: $run_exit" 1>&2
606 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000607 elif [ "$run_checker" = "yes" ]; then
608 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
609 checker_exit="$?"
610 if [ "$checker_exit" != "0" ]; then
611 echo "checker exit status: $checker_exit" 1>&2
612 good_run="no"
613 else
614 good_run="yes"
615 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000616 else
617 good_run="yes"
618 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700619 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000620 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700621 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700622 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
623 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700624 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700625 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700626 max_name_length=$(getconf NAME_MAX ${tmp_dir})
627 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
628 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700629 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700630 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700631 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700632 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000633 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
634 # output == expected
635 good="yes"
636 echo "${test_dir}: succeeded!" 1>&2
637 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700638 fi
639fi
640
jeffhao5d1ac922011-09-29 17:41:15 -0700641(
Alex Lightbfac14a2014-07-30 09:41:21 -0700642 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700643 echo "${test_dir}: FAILED!"
644 echo ' '
645 echo '#################### info'
646 cat "${td_info}" | sed 's/^/# /g'
647 echo '#################### diffs'
Ian Rogers75deec02014-11-23 20:07:39 -0800648 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000
jeffhao5d1ac922011-09-29 17:41:15 -0700649 echo '####################'
650 echo ' '
651 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700652
653) 1>&2
654
655# Clean up test files.
656if [ "$always_clean" = "yes" -o "$good" = "yes" ]; then
657 cd "$oldwd"
658 rm -rf "$tmp_dir"
659 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
660 adb shell rm -rf $DEX_LOCATION
661 fi
662 if [ "$good" = "yes" ]; then
663 exit 0
664 fi
665fi
666
667
668(
669 if [ "$always_clean" = "yes" ]; then
670 echo "${TEST_NAME} files deleted from host "
671 if [ "$target_mode" == "yes" ]; then
672 echo "and from target"
673 fi
674 else
675 echo "${TEST_NAME} files left in ${tmp_dir} on host"
676 if [ "$target_mode" == "yes" ]; then
677 echo "and in ${DEX_LOCATION} on target"
678 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700679 fi
680
jeffhao5d1ac922011-09-29 17:41:15 -0700681) 1>&2
682
683exit 1